﻿Imports GrapeCity.Windows.SpreadSheet.UI
Imports GrapeCity.Windows.SpreadSheet.Data

Partial Public Class MainPage
    Inherits UserControl

    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub UserControl_Loaded(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        Me.GcSpreadSheet1.Sheets.Clear()
        'add custom worksheet to Sheetss collection
        Me.GcSpreadSheet1.Sheets.Add(New MyWorksheet())
        Dim sheet = Me.GcSpreadSheet1.ActiveSheet
        sheet.Rows(1).Height = 100
        sheet.Columns(1).Width = 150
    End Sub
End Class
Public Class ControlDrawingObject
    Inherits CustomDrawingObject
    Private _rootElement As Control
    Public Sub New(row As Integer, col As Integer, control As Control)
        MyBase.New(row, col)
        _rootElement = control
        Me.ShowDrawingObjectOnly = True
    End Sub
    Public Overrides ReadOnly Property RootElement() As FrameworkElement
        Get
            _rootElement.Margin = New Thickness(1)
            Return _rootElement
        End Get
    End Property
End Class
Public Class MyWorksheet
    Inherits Worksheet
    Public Property DrawingObjectVisible() As Boolean
        Get
            Return m_DrawingObjectVisible
        End Get
        Set(value As Boolean)
            m_DrawingObjectVisible = value
        End Set
    End Property
    Private m_DrawingObjectVisible As Boolean

    Public Overrides Function GetDrawingObject(row As Integer, column As Integer, rowCount As Integer, columnCount As Integer) As DrawingObject()
        'setting the rich text box for cell(1, 1)
        If row <> 1 OrElse column <> 1 Then
            Return MyBase.GetDrawingObject(row, column, rowCount, columnCount)
        End If

        Dim rtb As New RichTextBox()
        rtb.VerticalScrollBarVisibility = ScrollBarVisibility.Hidden
        Dim prgParagraph As New Paragraph()
        Dim rnMyText As New Run()
        rnMyText.Text = "This is some example text with ForeColor "
        'setting the fore color for text 
        rnMyText.Foreground = New SolidColorBrush(Colors.Brown)
        prgParagraph.Inlines.Add(rnMyText)

        Dim rnMyText2 As New Run()
        rnMyText2.Text = "Italic Text "
        'setting the font style to Italic
        rnMyText2.FontStyle = FontStyles.Italic
        prgParagraph.Inlines.Add(rnMyText2)

        'write underlined text
        Dim unText As New Underline()
        unText.Inlines.Add(New Run() With { _
         .Text = " This is some example text, underlined"})
        prgParagraph.Inlines.Add(unText)

        rtb.Blocks.Add(prgParagraph)

        Dim dobj As DrawingObject
        dobj = New ControlDrawingObject(row, column, rtb)
        Return New DrawingObject() {dobj}
    End Function

End Class